/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.provider;

import edu.kit.ipd.descartes.mm.adaptation.util.AdaptationAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AdaptationItemProviderAdapterFactory extends AdaptationAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
    /**
     * This keeps track of the root adapter factory that delegates to this adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Collection<Object> supportedTypes = new ArrayList<Object>();

    /**
     * This constructs an instance.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public AdaptationItemProviderAdapterFactory() {
        supportedTypes.add(IEditingDomainItemProvider.class);
        supportedTypes.add(IStructuredItemContentProvider.class);
        supportedTypes.add(ITreeItemContentProvider.class);
        supportedTypes.add(IItemLabelProvider.class);
        supportedTypes.add(IItemPropertySource.class);
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AdaptationProcessItemProvider adaptationProcessItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAdaptationProcessAdapter() {
        if (adaptationProcessItemProvider == null) {
            adaptationProcessItemProvider = new AdaptationProcessItemProvider(this);
        }

        return adaptationProcessItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.OverallGoal} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected OverallGoalItemProvider overallGoalItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.OverallGoal}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createOverallGoalAdapter() {
        if (overallGoalItemProvider == null) {
            overallGoalItemProvider = new OverallGoalItemProvider(this);
        }

        return overallGoalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.Strategy} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StrategyItemProvider strategyItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.Strategy}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStrategyAdapter() {
        if (strategyItemProvider == null) {
            strategyItemProvider = new StrategyItemProvider(this);
        }

        return strategyItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.Event} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EventItemProvider eventItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.Event}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEventAdapter() {
        if (eventItemProvider == null) {
            eventItemProvider = new EventItemProvider(this);
        }

        return eventItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.Objective} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ObjectiveItemProvider objectiveItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.Objective}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createObjectiveAdapter() {
        if (objectiveItemProvider == null) {
            objectiveItemProvider = new ObjectiveItemProvider(this);
        }

        return objectiveItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.WeightingFunction} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected WeightingFunctionItemProvider weightingFunctionItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.WeightingFunction}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createWeightingFunctionAdapter() {
        if (weightingFunctionItemProvider == null) {
            weightingFunctionItemProvider = new WeightingFunctionItemProvider(this);
        }

        return weightingFunctionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.WeightedMetric} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected WeightedMetricItemProvider weightedMetricItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.WeightedMetric}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createWeightedMetricAdapter() {
        if (weightedMetricItemProvider == null) {
            weightedMetricItemProvider = new WeightedMetricItemProvider(this);
        }

        return weightedMetricItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected WeightedTacticItemProvider weightedTacticItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createWeightedTacticAdapter() {
        if (weightedTacticItemProvider == null) {
            weightedTacticItemProvider = new WeightedTacticItemProvider(this);
        }

        return weightedTacticItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.Tactic} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected TacticItemProvider tacticItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.Tactic}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createTacticAdapter() {
        if (tacticItemProvider == null) {
            tacticItemProvider = new TacticItemProvider(this);
        }

        return tacticItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.StartAction} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StartActionItemProvider startActionItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.StartAction}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStartActionAdapter() {
        if (startActionItemProvider == null) {
            startActionItemProvider = new StartActionItemProvider(this);
        }

        return startActionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.StopAction} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected StopActionItemProvider stopActionItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.StopAction}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createStopActionAdapter() {
        if (stopActionItemProvider == null) {
            stopActionItemProvider = new StopActionItemProvider(this);
        }

        return stopActionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.LoopAction} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LoopActionItemProvider loopActionItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.LoopAction}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLoopActionAdapter() {
        if (loopActionItemProvider == null) {
            loopActionItemProvider = new LoopActionItemProvider(this);
        }

        return loopActionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.BranchAction} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BranchActionItemProvider branchActionItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.BranchAction}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBranchActionAdapter() {
        if (branchActionItemProvider == null) {
            branchActionItemProvider = new BranchActionItemProvider(this);
        }

        return branchActionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.ActionReference} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ActionReferenceItemProvider actionReferenceItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.ActionReference}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createActionReferenceAdapter() {
        if (actionReferenceItemProvider == null) {
            actionReferenceItemProvider = new ActionReferenceItemProvider(this);
        }

        return actionReferenceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.AdaptationPlan} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AdaptationPlanItemProvider adaptationPlanItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.AdaptationPlan}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAdaptationPlanAdapter() {
        if (adaptationPlanItemProvider == null) {
            adaptationPlanItemProvider = new AdaptationPlanItemProvider(this);
        }

        return adaptationPlanItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.Action} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ActionItemProvider actionItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.Action}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createActionAdapter() {
        if (actionItemProvider == null) {
            actionItemProvider = new ActionItemProvider(this);
        }

        return actionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AdaptationActionOperationItemProvider adaptationActionOperationItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAdaptationActionOperationAdapter() {
        if (adaptationActionOperationItemProvider == null) {
            adaptationActionOperationItemProvider = new AdaptationActionOperationItemProvider(this);
        }

        return adaptationActionOperationItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptation.Parameter} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ParameterItemProvider parameterItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.Parameter}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createParameterAdapter() {
        if (parameterItemProvider == null) {
            parameterItemProvider = new ParameterItemProvider(this);
        }

        return parameterItemProvider;
    }

    /**
     * This returns the root adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ComposeableAdapterFactory getRootAdapterFactory() {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object type) {
        return supportedTypes.contains(type) || super.isFactoryForType(type);
    }

    /**
     * This implementation substitutes the factory itself as the key for the adapter.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter adapt(Notifier notifier, Object type) {
        return super.adapt(notifier, this);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object adapt(Object object, Object type) {
        if (isFactoryForType(type)) {
            Object adapter = super.adapt(object, type);
            if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void addListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.addListener(notifyChangedListener);
    }

    /**
     * This removes a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void removeListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.removeListener(notifyChangedListener);
    }

    /**
     * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void fireNotifyChanged(Notification notification) {
        changeNotifier.fireNotifyChanged(notification);

        if (parentAdapterFactory != null) {
            parentAdapterFactory.fireNotifyChanged(notification);
        }
    }

    /**
     * This disposes all of the item providers created by this factory. 
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void dispose() {
        if (adaptationProcessItemProvider != null) adaptationProcessItemProvider.dispose();
        if (overallGoalItemProvider != null) overallGoalItemProvider.dispose();
        if (strategyItemProvider != null) strategyItemProvider.dispose();
        if (eventItemProvider != null) eventItemProvider.dispose();
        if (objectiveItemProvider != null) objectiveItemProvider.dispose();
        if (weightingFunctionItemProvider != null) weightingFunctionItemProvider.dispose();
        if (weightedMetricItemProvider != null) weightedMetricItemProvider.dispose();
        if (weightedTacticItemProvider != null) weightedTacticItemProvider.dispose();
        if (tacticItemProvider != null) tacticItemProvider.dispose();
        if (startActionItemProvider != null) startActionItemProvider.dispose();
        if (stopActionItemProvider != null) stopActionItemProvider.dispose();
        if (loopActionItemProvider != null) loopActionItemProvider.dispose();
        if (branchActionItemProvider != null) branchActionItemProvider.dispose();
        if (actionReferenceItemProvider != null) actionReferenceItemProvider.dispose();
        if (adaptationPlanItemProvider != null) adaptationPlanItemProvider.dispose();
        if (actionItemProvider != null) actionItemProvider.dispose();
        if (adaptationActionOperationItemProvider != null) adaptationActionOperationItemProvider.dispose();
        if (parameterItemProvider != null) parameterItemProvider.dispose();
    }

}
